<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\Kpi\Block\Adminhtml\System\Config;

use Magento\Backend\Block\Template\Context;
use Magento\Catalog\Model\ResourceModel\Eav\Attribute;
use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Eav\Model\Entity\Attribute\Set;
use Magento\Framework\View\Element\Html\Select;

/**
 * Renderer for Event Configuration
 */
class Kpimapping extends AbstractFieldArray
{
    /**
     * @var \Magento\Catalog\Model\ResourceModel\Eav\Attribute
     */
    protected $attributeFactory;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Catalog\Model\ResourceModel\Eav\Attribute $attributeFactory
     * @param array $data
     */
    public function __construct(
        Context $context,
        Attribute $attributeFactory,
        array $data = []
    ) {
        $this->attributeFactory = $attributeFactory;
        parent::__construct($context, $data);
    }

    /**
     * @return void
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareToRender()
    {
        $catalog_attributes_coll = $this->attributeFactory->getCollection()
            ->addFieldToFilter(Set::KEY_ENTITY_TYPE_ID, 4);

        $catalog_attributes = [];

        foreach ($catalog_attributes_coll as $a) {
            $attributeCode = $a->getAttributeCode();
            $catalog_attributes[$attributeCode] = $a->getFrontendLabel() . " - ($attributeCode)";
        }

        $catalog_attributes_block = $this->getLayout()
            ->createBlock(Select::class)
            ->setId($this->_getCellInputElementId('<%- _id %>', 'catalog_product_attribute'))
            ->setName($this->_getCellInputElementName('catalog_product_attribute'))
            ->setClass('select')
            ->setOptions($catalog_attributes);

        /*
         * If you add or change some columns name
         * remember to resave the config (kpi/table_configuration/fields) or it will not load properly
         */
        $this->addColumn('column_name', [
            'label' => __('Column Name')
        ]);

        $this->addColumn('catalog_product_attribute', [
            'label'    => __('Product Attribute'),
            'renderer' => $catalog_attributes_block
        ]);


        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add attribute');
    }

}
